/* --------------------------------------------------------
 Generated by Lukman Hakim using sql2java (http://sql2java.sourceforge.net/ )
 jdbc driver used at code generation time: net.sourceforge.jtds.jdbc.Driver
 
 Author : Lukman Hakim (lukman.uki@gmail.com) 
 Date Created : 26/10/2017
 --------------------------------------------------------
*/
package com.portofolio.entity;


import org.hibernate.annotations.ForeignKey;
import static com.portofolio.base.adapter.DatabaseAdapter.Constant.*;

import java.math.BigDecimal;

import  javax.persistence.*;
import  javax.validation.constraints.*;

import  lombok.AllArgsConstructor;
import  lombok.Getter;
import  lombok.NoArgsConstructor;
import  lombok.Setter;

import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.portofolio.entity.Departemen;
import com.portofolio.entity.Profile;
import com.portofolio.entity.vo.PenghasilanTidakKenaPajakId;

import org.hibernate.annotations.Type;



@Entity
@Table(name = "PenghasilanTidakKenaPajak_M",indexes = {@Index(name = "PenghasilanTidakKenaPajak_M_Index",  columnList="statusEnabled", unique = false) })
@Getter
@Setter
@AllArgsConstructor
@NoArgsConstructor
@JsonIgnoreProperties({ "hibernateLazyInitializer", "handler" })
public class PenghasilanTidakKenaPajak {
    
    @EmbeddedId
    private PenghasilanTidakKenaPajakId id ;
    
    private static final String cDefStatusPTKP = VARCHAR + AWAL_KURUNG + 75 + AKHIR_KURUNG ;
    @Column(name = "StatusPTKP", columnDefinition = cDefStatusPTKP)
    @NotNull(message = "penghasilantidakkenapajak.statusptkp.notnull")
    private String statusPTKP;
    
    private static final String cDefReportDisplay = VARCHAR + AWAL_KURUNG + 75 + AKHIR_KURUNG ;
    @Column(name = "ReportDisplay", columnDefinition = cDefReportDisplay)
    @NotNull(message = "penghasilantidakkenapajak.reportdisplay.notnull")
    private String reportDisplay;
    
    private static final String cDefDeskripsi = VARCHAR + AWAL_KURUNG + 150 + AKHIR_KURUNG ;
    @Column(name = "Deskripsi", columnDefinition = cDefDeskripsi)
    private String deskripsi;
    
    private static final String cDefKdStatusPerkawinan =INTEGER;
    @Column(name = "KdStatusPerkawinan", columnDefinition = cDefKdStatusPerkawinan)
    private Integer kdStatusPerkawinan;
    
    private static final String cDefQtyAnak =INTEGER;
    @Column(name = "QtyAnak", columnDefinition = cDefQtyAnak)
    private Integer qtyAnak;
    
    private static final String cDefTotalHargaPTKP = BIGDECIMAL + AWAL_KURUNG + "15,2" + AKHIR_KURUNG ;
    @Column(name = "TotalHargaPTKP", columnDefinition = cDefTotalHargaPTKP)
    @NotNull(message = "penghasilantidakkenapajak.totalhargaptkp.notnull")
    private BigDecimal totalHargaPTKP;
    
    private static final String cDefKodeExternal = VARCHAR + AWAL_KURUNG + 255 + AKHIR_KURUNG ;
    @Column(name = "KodeExternal", columnDefinition = cDefKodeExternal)
    private String kodeExternal;
    
    private static final String cDefNamaExternal = VARCHAR + AWAL_KURUNG + 75 + AKHIR_KURUNG ;
    @Column(name = "NamaExternal", columnDefinition = cDefNamaExternal)
    private String namaExternal;
    
    private static final String cDefKdDepartemen = VARCHAR + AWAL_KURUNG + 255 + AKHIR_KURUNG ;
    @Column(name = "KdDepartemen", columnDefinition = cDefKdDepartemen)
    @NotNull(message = "penghasilantidakkenapajak.kddepartemen.notnull")
    private String kdDepartemen;
    
    private static final String cDefStatusEnabled =INTEGER;
    @Column(name = "StatusEnabled", columnDefinition = cDefStatusEnabled)
    @NotNull(message = "penghasilantidakkenapajak.statusenabled.notnull")
    @Type(type = "org.hibernate.type.NumericBooleanType") private Boolean statusEnabled;
    
    private static final String cDefNoRec = VARCHAR + AWAL_KURUNG + 36 + AKHIR_KURUNG ;
    @Column(name = "NoRec", columnDefinition = cDefNoRec)
    @NotNull(message = "penghasilantidakkenapajak.norec.notnull")
    private String noRec;
    
    private static final String cDefVersion =INTEGER;
    @Version
    @Column(name = "version", nullable = false,  columnDefinition = cDefVersion)
    @NotNull(message = "penghasilantidakkenapajak.version.notnull")
    private Integer version;
    

    
    @ManyToOne(fetch= FetchType.LAZY)
    @JsonIgnore
    @JoinColumns({
        @JoinColumn(name="KdProfile", referencedColumnName="KdProfile",insertable=false, updatable=false),
    })
    //@ForeignKey(name="none")
     private Profile profile;
    
    @ManyToOne(fetch= FetchType.LAZY)
    @JsonIgnore
    @JoinColumns({
        @JoinColumn(name="KdProfile", referencedColumnName="KdProfile",insertable=false, updatable=false),
        @JoinColumn(name="KdDepartemen", referencedColumnName="KdDepartemen",insertable=false, updatable=false),
    })
    //@ForeignKey(name="none")
     private Departemen departemen;
    
    @ManyToOne(fetch = FetchType.LAZY)
	@JsonIgnore
	@JoinColumns({
			@JoinColumn(name = "KdProfile", referencedColumnName = "KdProfile", insertable = false, updatable = false),
			@JoinColumn(name = "KdStatusPerkawinan", referencedColumnName = "KdStatus", insertable = false, updatable = false),
	})
	//@ForeignKey(name="none")//
	private Status status;
	
	/*@ManyToOne(fetch = FetchType.LAZY)
	@JsonIgnore
	@JoinColumns({
			@JoinColumn(name = "KdProfile", referencedColumnName = "KdProfile", insertable = false, updatable = false),
			@JoinColumn(name = "statusPTKP", referencedColumnName = "KdStatus", insertable = false, updatable = false),
	})
	//@ForeignKey(name="none")//
	private Status status1;*/
}
